<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Models;

use Carbon\Carbon;
use App\Http\Base\BaseModel;

class RolelokasiitemModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "rolelokasiitem";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "roleLokasiItem";

    /**
     * primary key from table remember eloquent doesnt support composite primary key
     */
    protected $primaryKey = "id";
    /**
     * fillable property for eloquent attribute cast
     */
    protected $fillable = [
        "id", "roleId", "lokasiId", "date_updated"
    ];
    /**
     * Creating raw object from table that, this purpose for making you easier for remembering all attribute
     */


    /**
     * paging for default paging purpose
     * if you want to add new paging property you have to add the property in this array
     * you have to add the relation value
     * remember this is not suported casting value you have to handle by your self
     */
    protected $aliasPaging = [ ];

    /**
     * relation from ' . administratorgroup . ' by ' . roleId
     * join administratorgroup on administratorgroup.id = roleLokasiItem.roleId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationRoleId($alias = "roleId")
    {
        $this->getQuery()->join("roles as $alias", "$alias.id", "=", "roleLokasiItem.roleId");
        return $this;
    }

    /**
     * relation from ' . administratormenuacess . ' by ' . lokasiId
     * join administratormenuacess on administratormenuacess.id = roleLokasiItem.lokasiId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationLokasiId($alias = "lokasiId")
    {
        $this->getQuery()->join("lokasiitem as $alias", "$alias.id", "=", "roleLokasiItem.lokasiId");
        return $this;
    }

    public static function storeFromHO($data)
    {
        $modelExist = (new self())->getQuery()->where("roleLokasiItem.roleId", "=", $data->roleId)
            ->where("roleLokasiItem.lokasiId", "=", $data->lokasiId)
            ->first();
        if ($modelExist) {
            $model = self::find($modelExist->id);
            $model->roleId = $data->roleId;
            $model->lokasiId = $data->lokasiId;
            $model->date_updated = $data->date_updated;
            $model->update();
            (new LogsynckapalModel)->setLogSync("Role-SubInventory : ".$data->roleId." - ".$data->lokasiId, Carbon::now()->toDateTimeString(), "", "updated");
        } else {
            $model = new self();
            $model->roleId = $data->roleId;
            $model->lokasiId = $data->lokasiId;
            $model->date_updated = $data->date_updated;
            $model->save([], $data->id, 0);
            (new LogsynckapalModel)->setLogSync("Role-SubInventory : ".$data->roleId." - ".$data->lokasiId, Carbon::now()->toDateTimeString(), "", "inserted");
        }
        echo $data->roleId . " sync", PHP_EOL;
    }

    public static function getRoleLokasiItem()
    {
        $url = $GLOBALS["env"]["HEAD_OFFICE_URL"] . "/api/sync_role_lokasiitem";
        $syncTable = (new \App\Http\Models\SyncUtilities\SyncTableHandlerModel())->getQuery()->where("sync_table.id", "=", 15)->first();
        $fetch = true;
        $page = 1;
        (new LogsynckapalModel)->setLogSync("Role-SubInventory - HO to Role", Carbon::now()->toDateTimeString(), "", "start");
        // $isEmptied = false; // \App\Http\Models\RolelokasiitemModel::truncate();
        do {
            if ($syncTable) {
                $syncHandler = new \App\Http\Handler\CurlHandler();
                $lastUpdate = Carbon::parse($syncTable->last_sync)->toAtomString();
                $lastUpdate = !empty($syncTable->last_sync) ? \Carbon\Carbon::parse($syncTable->last_sync)->toAtomString() : $lastUpdate;
                $url = $url . "?date_updated=" . $lastUpdate . "&page=" . $page;
                try {
                    $response = $syncHandler->setUrl($url)->send();
                    $res = json_decode($response, false);
                    $no = 1;
                    if (!empty($res->data)) {
                        if($page == 1) {
                            \App\Http\Models\RolelokasiitemModel::truncate();
                        }
                        foreach ($res->data as $item) {
                            echo "data " . $no;
                            \App\Http\Models\RolelokasiitemModel::storeFromHO($item);
                            $lastUpdate = $item->date_updated;
                            $no = $no + 1;
                        }
                        $sync = \App\Http\Models\SyncUtilities\SyncTableHandlerModel::find(15);
                        $sync->last_sync = $lastUpdate;
                        $sync->update();
                    } else $fetch = false;
                } catch (\Exception $e) {
                    echo $e->getMessage();
                    (new LogsynckapalModel)->setLogSync("Role-SubInventory - HO to Role", Carbon::now()->toDateTimeString(), $e->getMessage(), "failed");
                }
                $page = $page + 1;
            }
        } while ($fetch);
        (new LogsynckapalModel)->setLogSync("Role-SubInventory - HO to Role", Carbon::now()->toDateTimeString(), "", "success");
    }
}